#include <WINDOWS.H>
#include <oci.h>

static OCIEnv	*envhp;
static OCIError *errhp;
static OCIStmt	*stmthp;

void checkerr ( 
	OCIError	*errhp,
	sword		status )
{

text errbuf[512];
sb4  errcode = 0;

switch (status)
	{
	case OCI_SUCCESS:
		break;
	case OCI_SUCCESS_WITH_INFO:
		#ifdef _DEBUG
			MessageBox( NULL, "OCI_SUCCESS_WITH_INFO", "DBHandleDemo", MB_ICONEXCLAMATION | MB_OK );
		#endif
		break;
	case OCI_NEED_DATA:
		#ifdef _DEBUG
			MessageBox( NULL, "OCI_NEED_DATA", "DBHandleDemo", MB_ICONEXCLAMATION | MB_OK );
		#endif
		break;
	case OCI_NO_DATA:
		#ifdef _DEBUG
			MessageBox( NULL, "OCI_NO_DATA", "DBHandleDemo", MB_ICONEXCLAMATION | MB_OK );
		#endif
		break;
	case OCI_ERROR:
		(void) OCIErrorGet((dvoid *)errhp, (ub4) 1, (text *) NULL, &errcode, errbuf, (ub4) sizeof(errbuf), OCI_HTYPE_ERROR);
		#ifdef _DEBUG
			MessageBox( NULL, (LPSTR)errbuf, "DBHandleDemo", MB_ICONEXCLAMATION | MB_OK );
		#endif
		break;
	case OCI_INVALID_HANDLE:
		#ifdef _DEBUG
			MessageBox( NULL, "OCI_INVALID_HANDLE", "DBHandleDemo", MB_ICONEXCLAMATION | MB_OK );
		#endif
		break;
	case OCI_STILL_EXECUTING:
		#ifdef _DEBUG
			MessageBox( NULL, "OCI_STILL_EXECUTE", "DBHandleDemo", MB_ICONEXCLAMATION | MB_OK );
		#endif
		break;
	case OCI_CONTINUE:
		#ifdef _DEBUG
			MessageBox( NULL, "OCI_CONTINUE", "DBHandleDemo", MB_ICONEXCLAMATION | MB_OK );
		#endif
		break;
	default:
		break;
	}
}

void cleanup()
{
	if (stmthp)
		(void) OCIHandleFree((dvoid *) stmthp, OCI_HTYPE_STMT);
	if (errhp)
		(void) OCIHandleFree((dvoid *) errhp, OCI_HTYPE_ERROR);
	if (envhp)
		(void) OCIHandleFree((dvoid *) envhp, OCI_HTYPE_ENV);
	return;
}

sb4 __declspec(dllexport) __stdcall AddEmployee ( 
	OCISvcCtx	*svchp,
	long		empno,
	LPCSTR		empname,
	LPCSTR		job,
	long		mgr,
	LPCSTR		hiredate,
	long		salary,
	long		comm,
	long		deptno )
{

sb2		empno_ind = 0, empname_ind = 0, job_ind = 0, mgr_ind = 0, hiredate_ind = 0, salary_ind = 0, comm_ind = 0, deptno_ind = 0 ;
OCIDate argdate;
sword	retval;
static sword status;
static text *insert = (text *) "INSERT INTO \"SCOTT\".\"EMP\" ( \"EMPNO\", \"ENAME\", \"JOB\", \"MGR\", \"HIREDATE\", \"SAL\", \"COMM\", \"DEPTNO\" ) VALUES ( :1, :2, :3, :4, :5, :6, :7, :8)";
static text *date_format = (text *) "DD-MON-YYYY";

static OCIBind *bnd1p = (OCIBind *) 0;
static OCIBind *bnd2p = (OCIBind *) 0;
static OCIBind *bnd3p = (OCIBind *) 0;
static OCIBind *bnd4p = (OCIBind *) 0;
static OCIBind *bnd5p = (OCIBind *) 0;
static OCIBind *bnd6p = (OCIBind *) 0;
static OCIBind *bnd7p = (OCIBind *) 0;
static OCIBind *bnd8p = (OCIBind *) 0;

retval = OCIEnvInit( 
	(OCIEnv **) &envhp, 
	OCI_DEFAULT, 
	(size_t) 0, 
	(dvoid **) 0 );
if (retval != 0)
{
	#ifdef _DEBUG
		MessageBox( NULL, "OCIEnvInit() Failed", "DBHandleDemo", MB_ICONEXCLAMATION | MB_OK );
	#endif
	return -1;
}

retval = OCIHandleAlloc( 
	(dvoid *) envhp, 
	(dvoid **) &errhp, 
	OCI_HTYPE_ERROR, 
	(size_t) 0, 
	(dvoid **) 0);
if (retval != 0)
{
	#ifdef _DEBUG
		MessageBox( NULL, "OCIHandleAlloc Failed", "DBHandleDemo", MB_ICONEXCLAMATION | MB_OK );
	#endif
	return -1;
}

retval = OCIHandleAlloc( 
	(dvoid *) envhp, 
	(dvoid **) &stmthp,
	OCI_HTYPE_STMT, 
	(size_t) 0, 
	(dvoid **) 0);
if (retval != 0)
{
	#ifdef _DEBUG
		MessageBox( NULL, "OCIHandleAlloc Failed", "DBHandleDemo", MB_ICONEXCLAMATION | MB_OK );
	#endif
	return -1;
}

retval = OCIStmtPrepare (
	stmthp,
	errhp,
	insert,
	(ub4) strlen((char *) insert),
	(ub4) OCI_NTV_SYNTAX,
	(ub4) OCI_DEFAULT);
if (retval != 0)
{
	checkerr( errhp, retval );
	return -1;
}

if (empno == 0) 
{
	#ifdef _DEBUG
		MessageBox( NULL, "EMPNO was NULL", "DBHandleDemo", MB_ICONEXCLAMATION | MB_OK );
	#endif
	return -1;
}

if ((text *) empname == 0) 
{
	#ifdef _DEBUG
		MessageBox( NULL, "EMPNAME was NULL", "DBHandleDemo", MB_ICONEXCLAMATION | MB_OK );
	#endif
	return -1;
}
if (strlen((LPSTR)empname) == 0) 
{
	#ifdef _DEBUG
		MessageBox( NULL, "EMPNAME was an empty string", "DBHandleDemo", MB_ICONEXCLAMATION | MB_OK );
	#endif
	return -1;
}

if ((text *)job == 0) 
{
	#ifdef _DEBUG
		MessageBox( NULL, "JOB was NULL", "DBHandleDemo", MB_ICONEXCLAMATION | MB_OK );
	#endif
	return -1;
}
if (strlen((LPSTR)job) == 0) 
{
	#ifdef _DEBUG
		MessageBox( NULL, "JOB was an empty string", "DBHandleDemo", MB_ICONEXCLAMATION | MB_OK );
	#endif
	return -1;
}

if (mgr == 0) 
{
	#ifdef _DEBUG
		MessageBox( NULL, "MGR was NULL", "DBHandleDemo", MB_ICONEXCLAMATION | MB_OK );
	#endif
	return -1;
}

if ((text *)hiredate == 0) 
{
	#ifdef _DEBUG
		MessageBox( NULL, "HIREDATE was NULL", "DBHandleDemo", MB_ICONEXCLAMATION | MB_OK );
	#endif
	return -1;
}
if (strlen((LPSTR)hiredate) == 0) 
{
	#ifdef _DEBUG
		MessageBox( NULL, "HIREDATE was an empty string", "DBHandleDemo", MB_ICONEXCLAMATION | MB_OK );
	#endif
	return -1;
}

if (status = 
		OCIDateFromText( 
			(OCIError *)errhp,
			(CONST text *)hiredate,
			(ub4) strlen((LPSTR)hiredate),
			(CONST text *) date_format,
			(ub1) strlen((LPSTR)date_format),
			(text *) 0,
			-1,
			(OCIDate *) &argdate))
{
	checkerr(errhp, status);
	return -1;
}

if (salary == 0) 
{
	#ifdef _DEBUG
		MessageBox( NULL, "SALARY was NULL", "DBHandleDemo", MB_ICONEXCLAMATION | MB_OK );
	#endif
	return -1;
}

if (comm == 0)
{
	#ifdef _DEBUG
		MessageBox( NULL, "COMM was NULL", "DBHandleDemo", MB_ICONEXCLAMATION | MB_OK );
	#endif
	//The commission can be null, the comm_ind will tell OCI to inser a null
	comm_ind = -1 ;
	//return -1;
}

if (deptno == 0) 
{
	#ifdef _DEBUG
		MessageBox( NULL, "DEPTNO was NULL", "DBHandleDemo", MB_ICONEXCLAMATION | MB_OK );
	#endif
	return -1;
}

if (status =
		OCIBindByName(
			stmthp, 
			&bnd1p, 
			errhp, 
			(text *) ":1",
			2, 
			&empno,
			sizeof ( empno ), 
			SQLT_INT, 
			(dvoid *) &empno_ind,
			(ub2 *) 0,
			(ub2 *) 0,
			(ub4) 0,
			(ub4 *) 0,
			OCI_DEFAULT))
{
	checkerr(errhp, status);
	return -1;
}
			
if (status = 
		OCIBindByName(
			stmthp, 
			&bnd2p, 
			errhp, 
			(text *) ":2",
			2, 
			(dvoid *) empname,
			(sb4) strlen((LPSTR)empname)+1, 
			SQLT_STR, 
			(dvoid *) &empname_ind,
			(ub2 *) 0, 
			(ub2 *) 0, 
			(ub4) 0, 
			(ub4 *) 0, 
			OCI_DEFAULT))
{
	checkerr(errhp, status);
	return -1;
}

if (status = 
		OCIBindByName(
			stmthp, 
			&bnd3p, 
			errhp, 
			(text *) ":3",
			strlen ( ":3" ), 
			(ub1 *) job,
			(sb4) strlen((LPSTR)job)+1, 
			SQLT_STR, 
			(dvoid *) &job_ind,
			(ub2 *) 0, 
			(ub2 *) 0, 
			(ub4) 0, 
			(ub4 *) 0, 
			OCI_DEFAULT))
{
	checkerr(errhp, status);
	return -1;
}

if (status = 
		OCIBindByName(
			stmthp, 
			&bnd4p, 
			errhp, 
			(text *) ":4",
			2, 
			&mgr,
			sizeof ( mgr ), 
			SQLT_INT, 
			(dvoid *) &mgr_ind,
			(ub2 *) 0, 
			(ub2 *) 0, 
			(ub4) 0, 
			(ub4 *) 0, 
			OCI_DEFAULT))
{
	checkerr(errhp, status);
	return -1;
}

if (status = 
		OCIBindByName(
			stmthp, 
			&bnd5p, 
			errhp, 
			(text *) ":5",
			2, 
			(dvoid *) &argdate,
			sizeof(argdate), 
			SQLT_ODT, 
			(dvoid *) &hiredate_ind,
			(ub2 *) 0, 
			(ub2 *) 0, 
			(ub4) 0, 
			(ub4 *) 0, 
			OCI_DEFAULT))
{
	checkerr(errhp, status );
	return -1;
} 

if (status = 
		OCIBindByName(
			stmthp, 
			&bnd6p, 
			errhp, 
			(text *) ":6",
			2, 
			&salary,
			sizeof ( salary ), 
			SQLT_INT, 
			(dvoid *) &salary_ind,
			(ub2 *) 0, 
			(ub2 *) 0, 
			(ub4) 0, 
			(ub4 *) 0, 
			OCI_DEFAULT))
{
	checkerr(errhp, status);
	return -1;
}

if (status = 
		OCIBindByName(
			stmthp, 
			&bnd7p, 
			errhp, 
			(text *) ":7",
			2, 
			&comm,
			sizeof ( comm ), 
			SQLT_INT, 
			(dvoid *) &comm_ind,
			(ub2 *) 0, 
			(ub2 *) 0, 
			(ub4) 0, 
			(ub4 *) 0, 
			OCI_DEFAULT))
{
	checkerr(errhp, status);
	return -1;
}

if (status = 
		OCIBindByName(
			stmthp, 
			&bnd8p, 
			errhp, 
			(text *) ":8",
			2, 
			&deptno,
			sizeof ( deptno ), 
			SQLT_INT, 
			(dvoid *) &deptno_ind,
			(ub2 *) 0, 
			(ub2 *) 0, 
			(ub4) 0, 
			(ub4 *) 0, 
			OCI_DEFAULT))
{
	checkerr(errhp, status);
	return -1;
}

if (status = 
	OCIStmtExecute(
		(OCISvcCtx *) svchp,
		(OCIStmt *) stmthp,
		(OCIError *) errhp,
		(ub4) 1,
		(ub4) 0,
		(CONST OCISnapshot *) NULL,
		(OCISnapshot *) NULL,
		OCI_DEFAULT)) 
{
	checkerr ( errhp, status );
	return -1;
}

if (status = OCITransCommit(svchp, errhp, 0))
{
	checkerr ( errhp, status );
	return -1;
}

cleanup();
return 0;

}
